Index: /main/waeup.sirp/trunk/src/waeup/sirp/browser/breadcrumbs.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/breadcrumbs.py	(revision 7332)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/browser/breadcrumbs.py	(revision 7333)
@@ -109,8 +109,8 @@
         return (self.context, 'administration')
 
-class FacultyContainerBreadcrumb(Breadcrumb):
+class FacultiesContainerBreadcrumb(Breadcrumb):
     """A breadcrumb for faculty containers.
     """
-    grok.context(interfaces.IFacultyContainer)
+    grok.context(interfaces.IFacultiesContainer)
     title = u'Academics'
 
@@ -179,14 +179,14 @@
     grok.context(interfaces.ICertificate)        
 
-class CourseContainerBreadcrumb(Breadcrumb):
+class CoursesContainerBreadcrumb(Breadcrumb):
     """ We don't want course container breadcrumbs.
     """
-    grok.context(interfaces.ICourseContainer)
+    grok.context(interfaces.ICoursesContainer)
     grok.implements(IBreadcrumbIgnorable)
 
-class CertificateContainerBreadcrumb(Breadcrumb):
+class CertificatesContainerBreadcrumb(Breadcrumb):
     """ We don't want course container breadcrumbs.
     """
-    grok.context(interfaces.ICertificateContainer)
+    grok.context(interfaces.ICertificatesContainer)
     grok.implements(IBreadcrumbIgnorable)
 
Index: /main/waeup.sirp/trunk/src/waeup/sirp/browser/interfaces.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/interfaces.py	(revision 7332)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/browser/interfaces.py	(revision 7333)
@@ -23,6 +23,6 @@
     ISIRPObject, IUniversity, IUsersContainer, IDataCenter)
 from waeup.sirp.university.interfaces import (
-    IFacultyContainer, IFaculty, IFacultyAdd, IDepartment, IDepartmentAdd,
-    ICourseContainer, ICourse, ICourseAdd, ICertificateContainer,
+    IFacultiesContainer, IFaculty, IFacultyAdd, IDepartment, IDepartmentAdd,
+    ICoursesContainer, ICourse, ICourseAdd, ICertificatesContainer,
     ICertificate, ICertificateAdd, ICertificateCourse, ICertificateCourseAdd)
 
Index: /main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py	(revision 7332)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py	(revision 7333)
@@ -41,5 +41,5 @@
     SIRPDisplayFormPage, NullValidator)
 from waeup.sirp.browser.interfaces import (
-    IUniversity, IFacultyContainer, IFaculty, IFacultyAdd,
+    IUniversity, IFacultiesContainer, IFaculty, IFacultyAdd,
     IDepartment, IDepartmentAdd, ICourse, ICourseAdd, ICertificate,
     ICertificateAdd, ICertificateCourse, ICertificateCourseAdd)
@@ -539,5 +539,5 @@
     """General search page for the academics section.
     """
-    grok.context(IFacultyContainer)
+    grok.context(IFacultiesContainer)
     grok.name('search')
     grok.template('searchpage')
@@ -1173,11 +1173,11 @@
 
 #
-# FacultyContainer pages...
-#
-
-class FacultyContainerPage(SIRPPage):
+# FacultiesContainer pages...
+#
+
+class FacultiesContainerPage(SIRPPage):
     """ Index page for faculty containers.
     """
-    grok.context(IFacultyContainer)
+    grok.context(IFacultiesContainer)
     grok.require('waeup.viewAcademics')
     grok.name('index')
@@ -1187,11 +1187,11 @@
     grok.template('facultypage')
 
-class FacultyContainerManageFormPage(SIRPEditFormPage):
+class FacultiesContainerManageFormPage(SIRPEditFormPage):
     """Manage the basic properties of a `Faculty` instance.
     """
-    grok.context(IFacultyContainer)
+    grok.context(IFacultiesContainer)
     grok.name('manage')
     grok.require('waeup.manageUniversity')
-    grok.template('facultycontainermanagepage')
+    grok.template('facultiescontainermanagepage')
     pnav = 1
     taboneactions = ['Add faculty', 'Remove selected','Cancel']
@@ -1206,5 +1206,5 @@
         tabs.need()
         warning.need()
-        return super(FacultyContainerManageFormPage, self).update()
+        return super(FacultiesContainerManageFormPage, self).update()
 
     @jsaction('Remove selected')
@@ -1227,5 +1227,5 @@
     """ Page form to add a new faculty to a faculty container.
     """
-    grok.context(IFacultyContainer)
+    grok.context(IFacultiesContainer)
     grok.require('waeup.manageUniversity')
     grok.name('add')
Index: /main/waeup.sirp/trunk/src/waeup/sirp/browser/viewlets.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/viewlets.py	(revision 7332)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/browser/viewlets.py	(revision 7333)
@@ -22,9 +22,9 @@
 from zope.traversing.browser import absoluteURL
 from waeup.sirp.browser.pages import (
-    UniversityPage, FacultyContainerPage, DatacenterPage, FacultyPage,
+    UniversityPage, FacultiesContainerPage, DatacenterPage, FacultyPage,
     DepartmentPage, CoursePage, CertificatePage, CertificateCoursePage,
     UsersContainerPage, UserManageFormPage)
 from waeup.sirp.browser.interfaces import (
-    IFacultyContainer, IFaculty, IDepartment, ICourse, ICertificate,
+    IFacultiesContainer, IFaculty, IDepartment, ICourse, ICertificate,
     ICertificateCourse, IBreadcrumbContainer, IUniversity, IUsersContainer)
 from waeup.sirp.interfaces import (ISIRPObject, ISIRPXMLExporter,
@@ -396,16 +396,16 @@
     text = 'Edit settings'
 
-class ManageFacultyContainerActionButton(ManageActionButton):
+class ManageFacultiesContainerActionButton(ManageActionButton):
     """ 'Manage settings' button for faculties.
     """
-    grok.context(IFacultyContainer)
-    grok.view(FacultyContainerPage)
+    grok.context(IFacultiesContainer)
+    grok.view(FacultiesContainerPage)
     text = 'Manage academic section'
 
-class SearchFacultyContainerActionButton(ManageActionButton):
+class SearchFacultiesContainerActionButton(ManageActionButton):
     """ 'Manage settings' button for faculties.
     """
-    grok.context(IFacultyContainer)
-    grok.view(FacultyContainerPage)
+    grok.context(IFacultiesContainer)
+    grok.view(FacultiesContainerPage)
     text = 'Search academic section'
     icon = 'actionicon_search.png'
@@ -468,6 +468,6 @@
 
 #class AddFacultyActionButton(AddActionButton):
-#    grok.context(IFacultyContainer)
-#    grok.view(FacultyContainerPage)
+#    grok.context(IFacultiesContainer)
+#    grok.view(FacultiesContainerPage)
 #    text = 'Add faculty'
     
@@ -504,6 +504,6 @@
 
 #class RemoveFacultyActionButton(RemoveActionButton):
-#    grok.context(IFacultyContainer)
-#    grok.view(FacultyContainerPage)
+#    grok.context(IFacultiesContainer)
+#    grok.view(FacultiesContainerPage)
 #    text = 'Remove faculty'
    
@@ -715,10 +715,10 @@
 
 
-class FacultyContainerListHead(grok.Viewlet):
+class FacultiesContainerListHead(grok.Viewlet):
     """The header line of faculty container subobject lists.
     """
     grok.order(1)
     grok.viewletmanager(SubobjectLister)
-    grok.context(IFacultyContainer)
+    grok.context(IFacultiesContainer)
     grok.require('waeup.viewAcademics')
 
Index: /main/waeup.sirp/trunk/src/waeup/sirp/university/__init__.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/university/__init__.py	(revision 7332)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/university/__init__.py	(revision 7333)
@@ -1,7 +1,7 @@
 # Make this a package.
 from waeup.sirp.university.course import Course
-from waeup.sirp.university.coursecontainer import CourseContainer
+from waeup.sirp.university.coursescontainer import CoursesContainer
 from waeup.sirp.university.faculty import Faculty
-from waeup.sirp.university.facultycontainer import FacultyContainer
+from waeup.sirp.university.facultiescontainer import FacultiesContainer
 __all__ = (
-    'Course', 'CourseContainer', 'Faculty', 'FacultyContainer')
+    'Course', 'CoursesContainer', 'Faculty', 'FacultiesContainer')
Index: /main/waeup.sirp/trunk/src/waeup/sirp/university/batching.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/university/batching.py	(revision 7332)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/university/batching.py	(revision 7333)
@@ -28,5 +28,5 @@
 from waeup.sirp.interfaces import IBatchProcessor
 from waeup.sirp.university.interfaces import (
-    IFacultyContainer, IFaculty, ICourse, IDepartment, ICertificate,
+    IFacultiesContainer, IFaculty, ICourse, IDepartment, ICertificate,
     ICertificateCourse)
 from waeup.sirp.utils.batching import BatchProcessor
Index: /main/waeup.sirp/trunk/src/waeup/sirp/university/certificatescontainer.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/university/certificatescontainer.py	(revision 7333)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/university/certificatescontainer.py	(revision 7333)
@@ -0,0 +1,131 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+"""Containers for certificates.
+"""
+import grok
+from zope.catalog.interfaces import ICatalog
+from zope.component.interfaces import IFactory
+from zope.component import queryUtility
+from zope.interface import implementedBy
+from waeup.sirp.interfaces import DuplicationError
+from waeup.sirp.university.interfaces import (
+    ICertificatesContainer, ICertificate)
+
+class CertificatesContainer(grok.Container):
+    """A storage for certificates.
+
+    A :class:`CertificatesContainer` stores
+    :class:`waeup.sirp.university.Certificate` instances.
+
+    It is a :class:`grok.Container` basically acting like a standard
+    Python dictionary. That means you can add certificates like items
+    in a normal dictionary and also get certificates by using
+    :meth:`values`, :meth:`keys`, and :meth:`items`.
+
+    This container type is picky about its contents: only real
+    certificates can be stored here and each new certificate must
+    provide a unique `code`. See :meth:`addCertificate` for details.
+
+    Each :class:`CertificatesContainer` provides
+    :class:`ICertificatesContainer`.
+    """
+    grok.implements(ICertificatesContainer)
+    grok.require('waeup.manageUniversity')
+
+    def __setitem__(self, name, certificate):
+        """Insert `certificate` with `name` as key into container.
+
+        The `certificate` must be an object implementing
+        :class:`waeup.sirp.university.interfaces.ICertificate`. If
+        not, a :exc:`TypeError` is raised.
+
+        If the certificate `code` does not equal `name` a
+        :exc:`ValueError` is raised.
+
+        If the `code` attribute of `certificate` is already in use by
+        another certificate stored in the local site
+        (:class:`waeup.sirp.app.University` instance), then a
+        :exc:`waeup.sirp.interfaces.DuplicationError` will be raised.
+
+        If `name` is already used as a key, a :exc:`KeyError` will be
+        raised.
+        """
+        if not ICertificate.providedBy(certificate):
+            raise TypeError('CertificatesContainers contain only '
+                            'ICertificate instances')
+
+        # Only accept certs with code == key.
+        if certificate.code != name:
+            raise ValueError('key must match certificate code: '
+                             '%s, %s' % (name, certificate.code))
+
+        # Lookup catalog. If we find none: no duplicates possible.
+        cat = queryUtility(ICatalog, name='certificates_catalog', default=None)
+        if cat is not None:
+            entries = cat.searchResults(
+                code=(certificate.code,certificate.code))
+            if len(entries) > 0:
+                raise DuplicationError(
+                    'Certificate exists already elsewhere.', entries)
+        else:
+            # No catalog, then this addition won't do harm to anything.
+            pass
+        super(CertificatesContainer, self).__setitem__(name, certificate)
+
+    def addCertificate(self, certificate):
+        """Add `certificate` to the container.
+
+        The certificate must be an object implementing
+        :class:`waeup.sirp.university.interfaces.ICertificate`. If
+        not, a :exc:`TypeError` is raised.
+
+        The certificate will be stored in the container with its
+        `code` attribute as key. If this key is already used for
+        another certificate stored in the local site
+        (:class:`waeup.sirp.app.University` instance), then a
+        :exc:`waeup.sirp.interfaces.DuplicationError` will be raised.
+        """
+        self[getattr(certificate, 'code', None)] = certificate
+
+    def clear(self):
+        """Remove all contents from the certificate container.
+
+        This methods is pretty fast and optimized. Use it instead of
+        removing all items manually yourself.
+        """
+        # This internal function is implemented in C and thus much
+        # faster as we could do it in pure Python.
+        self._SampleContainer__data.clear()
+        # The length attribute is 'lazy'. See `zope.container` for details.
+        # This way we make sure, the next time len() is called, it returns
+        # the real value and not a cached one.
+        del self.__dict__['_BTreeContainer__len']
+
+class CertificatesContainerFactory(grok.GlobalUtility):
+    """A factory for certificate containers.
+    """
+    grok.implements(IFactory)
+    grok.name(u'waeup.CertificatesContainer')
+    title = u"Create a new container for certificates.",
+    description = u"This factory instantiates new containers for certificates."
+
+    def __call__(self, *args, **kw):
+        return CertificatesContainer(*args, **kw)
+
+    def getInterfaces(self):
+        return implementedBy(CertificatesContainer)
Index: /main/waeup.sirp/trunk/src/waeup/sirp/university/course.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/university/course.py	(revision 7332)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/university/course.py	(revision 7333)
@@ -63,5 +63,5 @@
 def handle_course_removed(course, event):
     """If a course is deleted, we make sure that also referrers in a
-       certificatecontainer are removed.
+       certificatescontainer are removed.
     """
     code = course.code
Index: /main/waeup.sirp/trunk/src/waeup/sirp/university/coursescontainer.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/university/coursescontainer.py	(revision 7333)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/university/coursescontainer.py	(revision 7333)
@@ -0,0 +1,82 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+"""Course containers.
+"""
+import grok
+from zope.interface import implementedBy
+from zope.component.interfaces import IFactory, ComponentLookupError
+from zope.catalog.interfaces import ICatalog
+from zope.component import queryUtility
+from waeup.sirp.interfaces import DuplicationError
+from waeup.sirp.university.interfaces import ICoursesContainer, ICourse
+
+class CoursesContainer(grok.Container):
+    """See interfaces for description.
+    """
+    grok.implements(ICoursesContainer)
+    grok.require('waeup.manageUniversity')
+
+    def __setitem__(self, name, course):
+        """See corresponding docstring in certificatescontainer.py.
+        """
+        if not ICourse.providedBy(course):
+            raise TypeError('CoursesContainers contain only '
+                            'ICourse instances')
+
+        # Only accept courses with code == key.
+        if course.code != name:
+            raise ValueError('key must match course code: '
+                             '%s, %s' % (name, course.code))
+
+        # Lookup catalog. If we find none: no duplicates possible.
+        cat = queryUtility(ICatalog, name='courses_catalog', default=None)
+        if cat is not None:
+            entries = cat.searchResults(
+                code=(course.code,course.code))
+            if len(entries) > 0:
+                raise DuplicationError(
+                    'Course exists already elsewhere.', entries)
+        else:
+            # No catalog, then this addition won't do harm to anything.
+            pass
+        super(CoursesContainer, self).__setitem__(name, course)
+
+    def addCourse(self, course):
+        """See corresponding docstring in certificatescontainer.py.
+        """
+        self[getattr(course, 'code', None)] = course
+
+    def clear(self):
+        """See corresponding docstring and comments in certificatescontainer.py.
+        """
+        self._SampleContainer__data.clear()
+        del self.__dict__['_BTreeContainer__len']
+
+class CoursesContainerFactory(grok.GlobalUtility):
+    """A factory for course containers.
+    """
+    grok.implements(IFactory)
+    grok.name(u'waeup.CoursesContainer')
+    title = u"Create a new container for courses.",
+    description = u"This factory instantiates new containers for courses."
+
+    def __call__(self, *args, **kw):
+        return CoursesContainer(*args, **kw)
+
+    def getInterfaces(self):
+        return implementedBy(CoursesContainer)
Index: /main/waeup.sirp/trunk/src/waeup/sirp/university/department.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/university/department.py	(revision 7332)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/university/department.py	(revision 7333)
@@ -46,8 +46,8 @@
         self.title_prefix = title_prefix
         self.code = code
-        self.courses = createObject(u'waeup.CourseContainer')
+        self.courses = createObject(u'waeup.CoursesContainer')
         self.courses.__parent__ = self
         self.courses.__name__ = 'courses'
-        self.certificates = createObject(u'waeup.CertificateContainer')
+        self.certificates = createObject(u'waeup.CertificatesContainer')
         self.certificates.__parent__ = self
         self.certificates.__name__ = 'certificates'
Index: /main/waeup.sirp/trunk/src/waeup/sirp/university/facultiescontainer.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/university/facultiescontainer.py	(revision 7333)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/university/facultiescontainer.py	(revision 7333)
@@ -0,0 +1,67 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+import grok
+from zope.component.interfaces import IFactory
+from zope.interface import implementedBy
+from waeup.sirp.interfaces import ISIRPPluggable
+from waeup.sirp.university.interfaces import IFacultiesContainer, IFaculty
+
+class FacultiesContainer(grok.Container):
+    """See interfaces for description.
+    """
+    grok.implements(IFacultiesContainer)
+    grok.require('waeup.manageUniversity')
+
+    def addFaculty(self, faculty):
+        if not IFaculty.providedBy(faculty):
+            raise TypeError('FacultiesContainers contain only IFaculty instances')
+        self[faculty.code] = faculty
+        return
+
+class FacultiesContainerFactory(grok.GlobalUtility):
+    """A factory for faculty containers.
+    """
+    grok.implements(IFactory)
+    grok.name(u'waeup.FacultiesContainer')
+    title = u"Create a new facultiescontainer.",
+    description = u"This factory instantiates new containers for faculties."
+
+    def __call__(self, *args, **kw):
+        return FacultiesContainer(*args, **kw)
+
+    def getInterfaces(self):
+        return implementedBy(FacultiesContainer)
+
+class AcademicsPlugin(grok.GlobalUtility):
+    """A plugin that creates container for faculties inside a university.
+    """
+    grok.implements(ISIRPPluggable)
+    grok.name('faculties')
+
+    def setup(self, site, name, logger):
+        if 'faculties' in site.keys():
+            logger.warn('Could not create container for faculties in SIRP.')
+            return
+        site['faculties'] = FacultiesContainer()
+        logger.info('Container for faculties created')
+        return
+
+    def update(self, site, name, logger):
+        if not 'faculties' in site.keys():
+            self.setup(site, name, logger)
+
Index: /main/waeup.sirp/trunk/src/waeup/sirp/university/interfaces.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/university/interfaces.py	(revision 7332)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/university/interfaces.py	(revision 7333)
@@ -73,5 +73,5 @@
 IFacultyAdd['code'].order =  IFaculty['code'].order
 
-class IFacultyContainer(ISIRPContainer):
+class IFacultiesContainer(ISIRPContainer):
     """A container for faculties.
     """
@@ -124,5 +124,5 @@
 IDepartmentAdd['code'].order =  IDepartment['code'].order
 
-class ICourseContainer(ISIRPContainer):
+class ICoursesContainer(ISIRPContainer):
     """A container for faculties.
     """
@@ -248,5 +248,5 @@
 ICertificateAdd['code'].order =  ICertificate['code'].order
 
-class ICertificateContainer(ISIRPContainer):
+class ICertificatesContainer(ISIRPContainer):
     """A container for certificates.
     """
Index: /main/waeup.sirp/trunk/src/waeup/sirp/university/tests/test_certificatescontainer.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/university/tests/test_certificatescontainer.py	(revision 7333)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/university/tests/test_certificatescontainer.py	(revision 7333)
@@ -0,0 +1,139 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+"""
+Tests for certificate containers and related components.
+"""
+import shutil
+import tempfile
+import unittest
+from zope.component.hooks import setSite, clearSite
+from zope.interface.verify import verifyClass, verifyObject
+
+from waeup.sirp.app import University
+from waeup.sirp.interfaces import DuplicationError
+from waeup.sirp.testing import (
+    FunctionalLayer, doctestsuite_for_module, FunctionalTestCase)
+from waeup.sirp.university.certificate import Certificate
+from waeup.sirp.university.certificatescontainer import CertificatesContainer
+from waeup.sirp.university.interfaces import ICertificatesContainer
+
+
+class CertificatesContainerTests(FunctionalTestCase):
+
+    layer = FunctionalLayer
+
+    def setUp(self):
+        super(CertificatesContainerTests, self).setUp()
+
+        # Setup a sample site for each test
+        app = University()
+        self.dc_root = tempfile.mkdtemp()
+        app['datacenter'].setStoragePath(self.dc_root)
+
+        # Prepopulate the ZODB...
+        self.getRootFolder()['app'] = app
+        self.app = self.getRootFolder()['app']
+        setSite(self.app)
+
+    def tearDown(self):
+        super(CertificatesContainerTests, self).tearDown()
+        clearSite()
+        shutil.rmtree(self.dc_root)
+
+    def test_create(self):
+        # we can create instances
+        container = CertificatesContainer()
+        result = isinstance(container, CertificatesContainer)
+        assert result is True
+
+    def test_provides_icertificatescontainer(self):
+        # instances tell they provide their main interface
+        container = CertificatesContainer()
+        result = ICertificatesContainer.providedBy(container)
+        assert result is True
+
+    def test_interfaces(self):
+        # class and instances comply with their main interface
+        container = CertificatesContainer()
+        self.assertTrue(verifyClass(ICertificatesContainer, CertificatesContainer))
+        self.assertTrue(verifyObject(ICertificatesContainer, container))
+
+    def test_add_certificate_non_icertificate(self):
+        # we cannot add certificates that do not implement ICertificate.
+        container = CertificatesContainer()
+        self.assertRaises(
+            TypeError, container.addCertificate, 'some_string')
+
+    def test_add_certificate_no_duplicate_entry(self):
+        # we cannot add certificates that are registered already.
+        container = CertificatesContainer()
+        # We must place this container in the ZODB to make catalogs work.
+        self.app['certs'] = container
+        cert1 = Certificate(code="CERT1")
+        cert2 = Certificate(code="CERT1")
+        container.addCertificate(cert1)
+        self.assertRaises(
+            DuplicationError,
+            container.addCertificate, cert2)
+
+    def test_setitem_duplicate_entry(self):
+        # we cannot add certificates whose code exists already in catalog
+        container1 = CertificatesContainer()
+        container2 = CertificatesContainer()
+        self.app['certs1'] = container1 # enable catalogs
+        self.app['certs2'] = container2
+        cert1 = Certificate(code="CERT1")
+        cert2 = Certificate(code="CERT1")
+        self.app['certs1']['CERT1'] = cert1
+        self.assertRaises(
+            DuplicationError,
+            self.app['certs2'].__setitem__, 'CERT1', cert2)
+        assert len(container2) == 0
+
+    def test_setitem_name_unequal_code(self):
+        # we cannot add certificates whose code != key
+        container = CertificatesContainer()
+        self.app['certs'] = container # enable catalogs
+        cert1 = Certificate(code="CERT1")
+        self.assertRaises(
+            ValueError,
+            container.__setitem__, 'OtherKey', cert1)
+        assert len(container) == 0
+
+    def test_clear(self):
+        # clear() really empties the container.
+        container = CertificatesContainer()
+        self.app['certs'] = container # enable catalogs
+        cert1 = Certificate(code="CERT1")
+        cert2 = Certificate(code="CERT2")
+        container['CERT1'] = cert1
+        container['CERT2'] = cert2
+        container.clear()
+        assert len(container) == 0
+
+
+def test_suite():
+    suite = unittest.TestSuite((
+        unittest.makeSuite(CertificatesContainerTests),
+        doctestsuite_for_module(
+                'waeup.sirp.university.certificatescontainer'),
+        ))
+    return suite
+
+if __name__=='__main__':
+    unittest.main(defaultTest='test_suite')
Index: /main/waeup.sirp/trunk/src/waeup/sirp/university/tests/test_coursescontainer.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/university/tests/test_coursescontainer.py	(revision 7333)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/university/tests/test_coursescontainer.py	(revision 7333)
@@ -0,0 +1,39 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+
+# Test course containers
+
+import unittest
+from zope.interface.verify import verifyClass, verifyObject
+from waeup.sirp.university.interfaces import ICoursesContainer
+from waeup.sirp.university import CoursesContainer, Course
+
+class CoursesContainerTests(unittest.TestCase):
+
+    def test_ifaces(self):
+        container = CoursesContainer()
+        self.assertTrue(verifyClass(ICoursesContainer, CoursesContainer))
+        self.assertTrue(verifyObject(ICoursesContainer, container))
+
+    def test_setitem_name_ne_code(self):
+        # If we add a course under a wrong name that will give an error
+        container = CoursesContainer()
+        course = Course(code='MYCOURSE')
+        self.assertRaises(
+            ValueError,
+            container.__setitem__, 'NOTMYCOURSE', course)
